{-# OPTIONS -fglasgow-exts #-}
{-# OPTIONS -fallow-undecidable-instances #-}
{-# OPTIONS -fallow-overlapping-instances #-}
{-# OPTIONS -fth #-}
{-# OPTIONS -fgenerics #-}
module Lam where

import NominalBase
import NominalAbs
import NominalSubst
import SYBnew
import Basics
import Derive

data Lam = Var Name
	 | App Lam Lam
	 | Lam (Abs Name Lam)  deriving Show

$(derive [''Lam])

instance Nominal Lam where

instance Eq Lam where
    (==) = aeq

instance HasVar Lam where
    is_var (Var x) = Just x
    is_var y = Nothing
    var x = Var x


